﻿import { Action } from './Action.js';
import { toBool } from '../lib/utils.js';
/**
 * @class OpenUrl
 * @extends Action
 * @classdesc Действие Открыть адрес
 * Открыть любой адрес
 * */
export class OpenUrl extends Action {
    execute() {
        let address = this.Address;
        if (this.AddSessionId) {
            address = address + '&session_id=' + $sw.sessionId;
        }
        if (this._openNew === true) {
            window.open(address, '_blank');
        } else {
            if (this._frameId) {
                document.getElementById(this._frameId).datasource = address;
            } else {
                window.open(address, '_self');
            }
        }
    }

    get Address() {
        return this._address || '';
    }
    set Address(v) {
        this._address = v;
    }

    get OpenNew() {
        return typeof this._openNew === 'boolean' ? this._openNew : false;
    }
    set OpenNew(v) {
        this._openNew = toBool(v);
    }

    get FrameId(){
        return this._frameId;
    }
    set FrameId(v){
        this._frameId = v;
    }

    get AddSessionId(){
        return this._addSessionId;
    }
    set AddSessionId(v){
        this._addSessionId = v;
    }

}